/* Chinese Checkers */
#include "CC.h"

void dumpmove(void);

#define GOTO_FLAG() \
{ \
	if (quit) \
		goto Quit; \
	if (newgame) \
		goto NewGame; \
}

int main(int argc, char **argv)
{
	int bb[121];
	BOOL ingame=FALSE;

#ifdef DOGUI
	if (argc<2 || (argc>1 && argv[1][0]=='x'))
		GUI=TRUE;
#endif
	if ((!GUI && argc<3) || (argc==2 && !strcmp(argv[1],"--help")))
	{
		ccusage();
		return(0);
	}
	if(!GUI)
		view=TRUE;
	Argc=&argc;
	Argv=argv;
	loadplayers();
#ifdef DOGUI
	if (GUI)
	{
		if (!startgui())
		{
			printf("Couldn't open GUI interface!\n");
			exit(1);
		}
	}
#endif
	/* count number of configured players (in players.c) */
	/*for(configured_players=0;
		players[configured_players].name;
		configured_players++);*/
NewGame:
#ifdef DOGUI
	if(GUI && ingame)
	{
		int y;
		Uint32 black;
	
		black=SDL_MapRGB(s->format,0,0,0);
		SDL_BlitSurface(s,NULL,winbuf,NULL);
		for(y=0;y<s->h;y+=10)
		{
			SDL_Rect r;

			r.x=0;
			r.y=-y;
			SDL_FillRect(s,NULL,black);
			SDL_BlitSurface(winbuf,NULL,s,&r);
			UpdateWin(0);
		}
	}
#endif
	initnewgame();
	ingame=TRUE;
#ifdef DOGUI
	if (GUI)
	{
		handleIDCMP(-1); /* menu only */
		GOTO_FLAG();
	}
#endif
	while(!win && !crash) /* Game Loop */
	{
		if (view)
			vb(0);
		for(plyr=0; plyr<numplayers; plyr++) /* Players Loop */
		{
			player_err=1;
#ifdef DOGUI
			if (GUI)
			{
				handleIDCMP(-1); /* menu only */
				GOTO_FLAG();
			}
#endif
			tempstatus=status;
			if (playerlist[plyr] == 0 && !GUI)
				vb(1);
			player=games[numplayers-1][plyr];
			player_err=0;
			if (!crash && !win)
				do /* Player Try Loop */
				{
					memcpy(bb,b,121*sizeof(int));
#ifdef DOGUI
					if(GUI && !playerlist[plyr])
							rotate((6-(player-1))%6);
#endif
					players[playerlist[plyr]].player_move_func(&ps, player, tempstatus, player_err, bb, m);
					dumpmove();
#ifdef DOGUI
					if(GUI)
					{
						if(!playerlist[plyr])
						{
							rotate(player-1);
							rotatemove((6-(player-1))%6);
						}
						handleIDCMP(-1); /* menu only */
						GOTO_FLAG();
					}
#endif
					dumpmove();
					player_err = legalmv(player);
					if (!player_err)
					{
						try=0;
#ifdef DOGUI
						if (GUI)
						{
							rotatemove(player-1);
							MoveMarble(player);
							handleIDCMP(-1); /* menu only */
							GOTO_FLAG();
						}
#endif
						if(checkend(player)==player)
							win=player;
					}
					else
						try++;
					/* set to number of trys allowed */
					if (playerlist[plyr] && try==3)
					{
						status=player+6;
						tempstatus=try+4;
						crash=player;
						try=0;
					}
				} while (!crash && player_err && try && !win); /* Player Try Loop */
			else
			if (try < numplayers)
			{
				player=games[numplayers-1][plyr];
				if (win==player)
					status=3;
				if (!crash && win!=player)
					status=2;
				/*if (!playerlist[plyr])
					players[0].player_move_func(&ps, player, tempstatus, player_err);*/
				try++;
			}
			if (!crash && !win)
				rotate(rots[numplayers-1][plyr]);
		} /* Players Loop */
		if (!crash)
			status=1;
	} /* Game Loop */
	if (view)
		vb(1);
	if ((crash || win) && view)
	{
		if (win)
			player=win;
		else
			player=crash;
		for (plyr=0; plyr<numplayers && games[numplayers-1][plyr]!=player; plyr++);
		if (win)
			printf("\033[3%dm%d\033[38;0m) %s won.\n",win,win,players[playerlist[plyr]].name);
		else
			printf("\033[3%dm%d\033[38;0m) %s lost due to forfeit.\n",crash,crash,players[playerlist[plyr]].name);
	}
#ifdef DOGUI
	if (GUI)
	{
		if (win)
			player=win;
		else
			player=-crash;
		if(!autoexit)
		{
			gameover(player);
			GOTO_FLAG();
		}
	}
#endif
Quit:
#ifdef DOGUI
	if(GUI)
		SDL_Quit();
#endif
	if (win)
		exit(win);
	else
		exit(-crash);
}

void dumpmove()
{
#ifdef DEBUG
	int i;

	vb(2);
	for(i=0;i<100 && m[i]>-1; i++)
		printf("%d ",m[i]);
	printf("\nPress Enter: ");
	fflush(stdout);
	scanf("%*c");
#endif //DEBUG
}
