#include "CC.h"

void SizeButtons(int orientation, int num_buttons, Buttons *buttons, int *width, int *height)
{
	int th,w2,i,j,max_w=0,max_h=0,w,h;

	th=text_height();
	if(width)
		for(i=0;i<num_buttons;i++)
		{
			switch(buttons[i].type)
			{
				case BU_FLAG:
					w=text_width((char*)buttons[i].data);
					break;
				case BU_CYCLE:
					w=text_width(((char**)buttons[i].data)[0]);
					for(j=1;((char**)buttons[i].data)[j];j++)
					{
						w2=text_width(((char**)buttons[i].data)[j]);
						if(w2>w)
							w=w2;
					}
					break;
			}
			if(w>max_w)
				max_w=w;
		}
	w=EDGE*2+max_w;
	h=EDGE*2+th;
	if(orientation==BU_H)
		w=w*num_buttons;
	else
		h=h*num_buttons;
	if (width)
		*width=w;
	if (height)
		*height=h;
}

void DrawButtonText(Buttons *button, int x, int y, int w, int n)
{
	switch(button->type)
	{
		case BU_FLAG:
			textc_print(x,y,w,(char*)button->data);
			break;
		case BU_CYCLE:
			textc_print(x,y,w,((char**)button->data)[n]);
			break;
	}
}

int DrawButtons(int orientation, int num_buttons, Buttons *buttons, int sx, int sy)
{
	int x,y,w,h,i,j;

	x=sx;
	y=sy;
	h=text_height();
	SizeButtons(orientation,num_buttons,buttons,&w,NULL);
	if(orientation==BU_V)
		w=w-EDGE*2;
	else
		w=(w/num_buttons)-EDGE*2;
	for(i=0;i<num_buttons;i++)
	{
		add_hotspot(x+EDGE,y+EDGE,w,h,&buttons[i]);
		DrawGadgetBox(x+EDGE,y+EDGE,w,h);
		DrawButtonText(&buttons[i],x+EDGE,y+EDGE,w,0);
		if(orientation==BU_H)
			x+=EDGE*2+w;
		else
			y+=EDGE*2+h;
	}
	return(num_buttons*3);
}
