#include <math.h>
#include <unistd.h>
#include "CC.h"

#define ABS(a) ((a)<0?(-a):(a))
#define D2R(d) (d/57.2957795)

int slide(int, int, int, int);

void MoveMarble(int n)
{
	int r,c,x,y,i,j,w,h,old_x,old_y,old_r,old_c,anim_len,height,xx,yy;
	double dx,dy,a,da;
	Uint32 t, t2;
	SDL_Rect rect;

	if (m[0] == -1 || m[1] == -1)
	{
		errr("move.log","No move.\n");
		return;
	}
	if (n<1 || n>6)
	{
		errr("move.log","No player at move spot.\n");
		return;
	}
	if(torc(m[0],&r,&c)==-1)
	{
		errr("move.log","Invalid board position.\n");
		return;
	}

	w=ccmarble[n-1]->w;
	h=ccmarble[n-1]->h;
	
	if(animation)
	{
		SDL_BlitSurface(s,NULL,newwinbuf,NULL);
		for(i=0; m[i] != -1 && !quit && !newgame; i++)
		{
			if(i==0 || m[i+1]==-1)
			{
				if(torc(m[i],&old_r,&old_c)==-1)
				{
					errr("move.log","Invalid board position.\n");
					return;
				}
				rect.x=CtoX(old_c)-2;
				rect.y=RtoY(old_r)-2;
				SDL_BlitSurface(selection, NULL, s, &rect);
			}
		}
		UpdateWin(0);
		SDL_Delay(250);
		SDL_BlitSurface(newwinbuf,NULL,s,NULL);
	}

	for(i=1; m[i] != -1 && !quit && !newgame; i++)
	{
		old_r=r;
		old_c=c;
		old_x=CtoX(old_c);
		old_y=RtoY(old_r);
		rect.x=old_x;
		rect.y=old_y;
		rect.w=w;
		rect.h=h;
		SDL_BlitSurface(ccboard, &rect, s, &rect);
		SDL_BlitSurface(s,NULL,newwinbuf,NULL);
		if(torc(m[i],&r,&c)==-1)
		{
			errr("move.log","Invalid board position.\n");
			return;
		}
		x=CtoX(c);
		y=RtoY(r);
		if(animation)
		{
			//oldwinbuf=winbuf;
			//winbuf=newwinbuf;
			//SDL_BlitSurface(newwinbuf, NULL, s, NULL);
			if(old_r-r)
			{
				anim_len=ANIM_LEN_V;
				height=ANIM_HEIGHT_V;
			}
			else
			{
				anim_len=ANIM_LEN_S;
				height=ANIM_HEIGHT_S;
			}
			if (i==1 && slide(old_r,old_c,r,c))
			{
				anim_len>>=1;
				height>>=1;
			}
			dx=(x-old_x)/((double)anim_len+1);
			dy=(y-old_y)/((double)anim_len+1);
			da=180.0/(float)anim_len;
			t=SDL_GetTicks();
			for(j=1;j<anim_len && !quit && !newgame;j++)
			{
				j=t2-t;
				a=da*j;
				xx=old_x+(int)(dx*j);
				yy=old_y+(int)(dy*j-sin(D2R(a))*height);
				PutMarble(n-1, xx,yy);
				UpdateWin(0);
				handleIDCMP(-2);
				t2=SDL_GetTicks();
				rect.x=xx;
				rect.y=yy;
				rect.w=w;
				rect.h=h;
				SDL_BlitSurface(newwinbuf, &rect, s, &rect);
			}
			//winbuf=oldwinbuf;
			playsound(5);
		}
		PutMarble(n-1, x,y);
		UpdateWin(0);
	}
}
