#include <stdio.h>
#include <string.h>

#include "font.h"

JASDL_Font *JASDLFont_Create(SDL_Surface *src)
{
	JASDL_Font *f;
	Uint32 x,y,b;
	Uint8 a,rgb,doB;
	int i,go;
	
	f=(JASDL_Font*)malloc(sizeof(JASDL_Font));
	memset(f,0,sizeof(JASDL_Font));
	b=0;
	doB=1;
	i=0;
	for(x=0;i<62 && x<src->w;x++)
	{
		for(go=1,y=0;go && y<src->h;y++)
		{
			SDL_GetRGBA(JASDL_GetPixel(src,x,y),src->format,&rgb,&rgb,&rgb,&a);
			if(a)
				go=0;
		}
		if(go || (i==61 && x==src->w-1))
		{
			if(!doB)
			{
				SDL_Rect rect={b,0,x-b,src->h};

				//printf("%d) %d %dx%d\n",i,rect.x,rect.w,rect.h);
				(*f)[i]=JASDL_CopySurface(src,&rect);
				i++;
				doB=1;
				b=x;
			}
		}
		else if(doB)
		{
			b=x;
			doB=0;
		}
	}
	if(i!=62)
		JASDL_Exit("Font doesn't have 62 chars found!");
	SDL_FreeSurface(src);
	return(f);
}

void JASDLFont_DisplayFormatAlpha(JASDL_Font *f)
{
	int i;

	for(i=0;i<62;i++)
		(*f)[i]=JASDL_DisplayFormatAlpha((*f)[i]);
}

SDL_Surface *JASDLFont_GetChar(JASDL_Font *font, Uint8 c)
{
	if(c>='A' && c<='Z')
		return((*font)[c-'A']);
	else if(c>='a' && c<='z')
		return((*font)[c-'a'+26]);
	else if(c>='0' && c<='9')
		return((*font)[c-'0'+52]);
	else if(c==' ')
		return((*font)[53]); // '1' is used for the width of space
	return(NULL);
}

int JASDLFont_Width(JASDL_Font *font, char *str)
{
	Uint32 i,w;
	
	if(!str)
		return(0);
	for(w=i=0;str[i];i++)
	{
		SDL_Surface *p=JASDLFont_GetChar(font,str[i]);
		if(p)
			w+=p->w+1;
	}
	return(w);
}

void JASDLFont_putc(JASDL_Font *font, SDL_Rect *dst, Uint8 c)
{
	SDL_Surface *p;

	p=JASDLFont_GetChar(font, c);
	if(c==' ')
	{
		dst->x+=p->w;
		return;
	}
	else if(c=='\n')
	{
		dst->y+=JASDLFont_Height(font);
		dst->x=0;
		return;
	}
	if(p)
	{
		SDL_BlitSurface(p,NULL,s,dst);
		dst->x+=1+p->w;
	}
	/*else
		JASDL_Error("char 0x%02X='%c' not present in font",c,c);*/
}

void JASDLFont_puts(JASDL_Font *font, int x, int y, char *str)
{
	int i;
	SDL_Rect dst;

	dst.x=x;
	dst.y=y;
	for(i=0;str[i];i++)
	{
		JASDLFont_putc(font,&dst,str[i]);
		if(dst.x<x)
			dst.x=x;
	}
}

void JASDLFont_vprintf(JASDL_Font *font, int x, int y, char *format, va_list ap)
{
	static char str[1024];
	
	vsnprintf(str,1024,format,ap);
	str[1023]='\0';
	JASDLFont_puts(font,x,y,str);
}

void JASDLFont_printf(JASDL_Font *font, int x, int y, char *format, ...)
{
	va_list ap;
	va_start(ap, format);
	JASDLFont_vprintf(font,x,y,format,ap);
	va_end(ap);
}
