#include "CC.h"

Hotspots *hotspots=NULL,*hotspot=NULL;

void free_hotspots()
{
	Hotspots *h,*p;

	for(p=hotspots;p;h=p->next,free(p),p=h);
	hotspots=NULL;
}

void set_hotspot_state(void *data, int state)
{
	Hotspots *h;

	for(h=hotspots;h && h->button->data!=data;h=h->next);
	if (!h)
		return;
	h->state=state;
	DrawGadgetBox(h->x,h->y,h->w,h->h);
	DrawButtonText(h->button,h->x,h->y,h->w,h->state);
	UpdateWin(3);
}

#define test_hotspot(xp,yp,hp) \
	(xp>hp->x-EDGE && \
	 yp>hp->y-EDGE && \
	 xp<hp->x+hp->w+EDGE && \
	 yp<hp->y+hp->h+EDGE)

int do_hotspots()
{
	Hotspots *h;
	int i;

	for(h=hotspots;h && !test_hotspot(mouseX,mouseY,h);h=h->next);
	hotspot=h;
	if(!h)
		return(0);
	DrawInvGadgetBox(h->x,h->y,h->w,h->h);
	playsound(2);
	switch(h->button->type)
	{
		case BU_FLAG:
			h->state^=1;
			break;
		case BU_CYCLE:
			for(i=0;((char**)h->button->data)[i];i++);
			h->state=(h->state+1)%i;
			break;
	}
	DrawButtonText(h->button,h->x,h->y,h->w,h->state);
	UpdateWin(3);
	if(h->button->func)
		h->button->func();
	hotspot=NULL;
	if(!newgame&&!quit)
	{
		DrawGadgetBox(h->x,h->y,h->w,h->h);
		DrawButtonText(h->button,h->x,h->y,h->w,h->state);
		UpdateWin(3);
		//if(newwinbuf==winbuf)
		//	SDL_BlitSurface(newwinbuf,NULL,oldwinbuf,NULL);
	}
	return(1);
}

void add_hotspot(int x,int y,int w,int h,Buttons *button)
{
	Hotspots *hs;

	hs=malloc(sizeof(Hotspots));
	hs->x=x;
	hs->y=y;
	hs->w=w;
	hs->h=h;
	hs->state=0;
	hs->button=button;
	hs->next=hotspots;
	hotspots=hs;
}

int clear_hotspots()
{
	int ne=0;
	Hotspots *h;

	for(h=hotspots;h;h=h->next)
	{
		SDL_Rect r={
			h->x-EDGE, h->y-EDGE,
			h->w+EDGE*2, h->h+EDGE*2
		};
		SDL_BlitSurface(ccboard,&r,s,&r);
	}
	free_hotspots();
	return(ne);
}
