#include "player.h"
#include <stdio.h>
#include "CC.h"

extern void getanykey(void);
extern int getnum(int*);
extern int fromrc(int, int);
extern int torc(int, int*, int*);

int inarr(int, int*);
void findjump(int, int);
int slide(int, int, int, int);
void clrarea(void);
void clrerror(void);
void statprint(int);
void errprint(int);

int found=0;

/*checks if a number is in a move array*/
int inarr(int p, int *m)
{
	int ct;
	for (ct=0;m[ct]>-1;ct++) if (m[ct]==p) return(1);
	return(0);
}

/*this is a recursive function to find the jump indicated by the human*/
/*assuming it's possible*/ 
void findjump(int curmove, int dest)
{
	int ct,p=-1,j=-1,r,c;

	for(ct=0;(ct<6)&&(!found);ct++)
	{
		torc(m[curmove-1],&r,&c);
		j=0;
		switch(ct) /*the 6 possible directions are scanned*/
		 {
			 case 0 : p=fromrc(r+2,c+2); j=b[fromrc(r+1,c+1)]; break;
			 case 1 : p=fromrc(r+2,c-2); j=b[fromrc(r+1,c-1)]; break;
			 case 3 : p=fromrc(r  ,c+4); j=b[fromrc(r  ,c+2)]; break;
			 case 2 : p=fromrc(r  ,c-4); j=b[fromrc(r  ,c-2)]; break;
			 case 4 : p=fromrc(r-2,c+2); j=b[fromrc(r-1,c+1)]; break;
			 case 5 : p=fromrc(r-2,c-2); j=b[fromrc(r-1,c-1)]; break;
		 }

/*if the jump destination is empty and it is a valid board posistion and*/
/*the jumper marble is there and it isn't a redundant move then add it*/
		if ( j && p>-1 && !b[p] && !inarr(p,m) )
		{
			m[curmove]=p;
			m[curmove+1]=-1;
			if (dest!=p)
				findjump(curmove+1,dest);
			else
				found=1;
		}

/*otherwise end this move at the last spot checked, -1 ends the move array*/
	else
		if (!found) m[curmove]=-1;
	}
}

/*checks for a valid slide distance*/
int slide(int r, int c, int rr, int cc)
{   /*It works!  TRUST ME!!!*/
	return((( r+1==rr || r-1==rr ) && ( c+1==cc || c-1==cc ))||
		   ( r==rr && ( c+2==cc || c-2==cc )));
}

/*clear the move entry area on the screen*/
void clrarea() 
{
	printf("%c[17;24f%c[1K",27,27);
	printf("%c[18;24f%c[1K",27,27);
}

/*clear the status and error outpuit from the screen*/
void clrerror()
{
	printf("%c[1;24f%c[1K",27,27);
	printf("%c[2;24f%c[1K",27,27);
	printf("%c[3;24f%c[1K",27,27);
	printf("%c[5;24f%c[1K",27,27);
	printf("%c[6;24f%c[1K",27,27);
	printf("%c[7;24f%c[1K",27,27);
	printf("%c[9;24f%c[1K",27,27);
}

/*print the translation of the status from the driver to the screen*/
void statprint(int stat)
{
	printf("%c[5;1fStatus:\n%s",27,stat_str[stat]);
}

/*print the translation of the error status from the driver to the screen*/
void errprint(int err)
{
	printf("%c[1;1fError:\n%s",27,err_str[(err?12:0)]);
}
/*
//main human driver function//
int humanVT (int plyr, int status, int error)
{
	int r[2],c[2];

	//print stati//
	errprint(error);
	statprint(status);
	printf("%c[9;1fPlayer # %d",27,plyr);				//output player number//

	//if no move is to be made only pause for keypress//
	if ((status!=4)&&(status!=1)&&(status!=5)&&(status!=6)) 
	{
		printf("%c[17;1fPress Any Key",27);
		getanykey();
		clrarea();
		clrerror();
		printf ("%c[20;1f\n",27);
		return 0;
	}

	//enter moves//
	printf("%c[17;1fEnter from row : ",27);
	fflush(stdout);
	getnum(&r[0]);
	if (r[0]!=0)
	{
		printf("%c[18;1fEnter from column : ",27);
		getnum(&c[0]);
	}
	if (c[0]!=0)
	{
		clrarea();
		printf("%c[17;1fEnter to row : ",27);
		getnum(&r[1]);
	}
	if (r[1]!=0) 
	{
		printf("%c[18;1fEnter to column : ",27);
		getnum(&c[1]);
	}
	m[0]=fromrc(r[0],c[0]);
	m[1]=-1;
	m[2]=-1;
	found=0;

	//check if slide...if not then find the jump
	if (!slide(r[0],c[0],r[1],c[1]))
		findjump(1,fromrc(r[1],c[1]));
	else
		m[1]=fromrc(r[1],c[1]);

	//clear away output from screen
	clrarea();
	clrerror();
	printf ("%c[20;1f\n",27);

	return(0);
}*/
