#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "player.h"

char *name="Mike";

PlayerState *ps;

float mmevalmove(int m[40],int b[121]) /*weighted evaluation of the move*/
{

int	gr=0,gc, r,c, rr,cc, plyr,p[10],ct,ct2=0; 
float d,dd;
float r1=0,r2=0,r3=0,r4=0,r5=0,r6=0,r7=0,r8=0,r9=0; /*rules.*/

	plyr = b[m[0]];
	for(ct=0;ct<121;ct++) {
		if (b[ct]==plyr) 
			p[ct2++]=ct;		/*finds our pieces on the board*/
	}
	for(cc=0;m[cc]>-1;cc++); 	/*finds the ending move space in the m array*/
	ps->torc(m[0],&r,&c);			/*gets the row/col for beginning space*/
	ps->torc(m[cc-1],&rr,&cc);		/*gets the row/col for ending space */

	ps->torc(120,&gr, &gc);

	d=sqrt((gc-c)*(gc-c)+(gr-r)*(gr-r)); 	  /*compute distance for start space*/
	dd=sqrt((gc-cc)*(gc-cc)+(gr-rr)*(gr-rr)); /*compute distance for end space*/

	r1 = 1.0 * ((16-dd)/16.0);	/*ending space is closer to the goal*/
	r2 = 1.0 * (d/16.0);		/*move from the back and sides*/
	r3 = 3.0 * ((rr-r)/gr-1); 	/*total distance moved */
	return (r1+r2+r3); 
}

int mminarr(int p, int *m) /*check for existance of number in a move array*/
{
	int ct;
	
	for (ct=0;m[ct]>-1;ct++)
		if (m[ct]==p) 
			return(1);
	return(0);
}

/*recursive procedure to find the best posible no redundant jumping move*/
int mmfindjump(int *m,int *b,int curmove,int *bm,float *bw)
{
	int ct,ct2,p,j,r,c,cur;
	float w;

	for(ct=0;ct<6;ct++)
	{
		ps->torc(m[curmove-1],&r,&c);
		j=0;
		if (c < 13)
		{
			switch(ct)
			{
			case 0 : p=ps->fromrc(r+2,c+2); if(p>-1) j=b[ps->fromrc(r+1,c+1)]; break;
			case 1 : p=ps->fromrc(r+2,c-2); if(p>-1) j=b[ps->fromrc(r+1,c-1)]; break;
			case 3 : p=ps->fromrc(r  ,c+4); if(p>-1) j=b[ps->fromrc(r  ,c+2)]; break;
			case 2 : p=ps->fromrc(r  ,c-4); if(p>-1) j=b[ps->fromrc(r  ,c-2)]; break;
			case 4 : p=ps->fromrc(r-2,c+2); if(p>-1) j=b[ps->fromrc(r-1,c+1)]; break;
			case 5 : p=ps->fromrc(r-2,c-2); if(p>-1) j=b[ps->fromrc(r-1,c-1)]; break;
			}
		}
		else
		{
			switch(ct)
			{
			case 1 : p=ps->fromrc(r+2,c+2); if(p>-1) j=b[ps->fromrc(r+1,c+1)]; break;
			case 0 : p=ps->fromrc(r+2,c-2); if(p>-1) j=b[ps->fromrc(r+1,c-1)]; break;
			case 2 : p=ps->fromrc(r  ,c+4); if(p>-1) j=b[ps->fromrc(r  ,c+2)]; break;
			case 3 : p=ps->fromrc(r  ,c-4); if(p>-1) j=b[ps->fromrc(r  ,c-2)]; break;
			case 5 : p=ps->fromrc(r-2,c+2); if(p>-1) j=b[ps->fromrc(r-1,c+1)]; break;
			case 4 : p=ps->fromrc(r-2,c-2); if(p>-1) j=b[ps->fromrc(r-1,c-1)]; break;
			}
		}
		if ( j && p>-1 && !b[p] && !mminarr(p,m) )
		{
			m[curmove]=p;
			m[curmove+1]=-1;
			mmfindjump(m,b,curmove+1,bm,bw);
		}
		else
			if (m[1]!=-1)
			{
				m[curmove]=-1;
				c=curmove-1;
				cur=m[c];
				/*stay out of corners!*/
				if( cur==10 || cur==11 || cur==23 || cur==21 || cur==22 ||
					cur==34 || cur==86 || cur==98 || cur==99 || cur==97 ||
					cur==109 || cur==110 )
					m[c]=-1;
				w=mmevalmove(m,b);
				if ( w>=*bw && m[1]!=-1 )
				{
					*bw=w;
					for (ct2=0;m[ct2]>-1;ct2++) bm[ct2]=m[ct2];
					bm[ct2]=-1;
				}
			}
	}
	return 0;
}

/*import of slider to find the best slide move*/
int mmslider (int *b,int *bm, int *p, float *bw)
{
	int r,c,ct,ct2,ok=0,x,mv,cur;

	for(mv=0;(!ok)&&(mv<7);mv+=2)
		for(x=0; (!ok)&&(x<10) ;x++)
		{
			for(ct=mv+1; (!ok)&&(ct<3+mv) ;ct++)
			{
				ps->torc(p[x],&r,&c);
				if (c>=13)
				{
					if (ct==1) {c--; r++;}
					if (ct==2) {c++; r++;}
					if (ct==3) 
					{
						for (ct2=r-3; ct2<c && (ps->fromrc(r+1,ct2)==-1 || b[ps->fromrc(r+1,ct2)]);ct2+=2);
						if (!b[ps->fromrc(r+1,ct2)]) c-=2;
					}
					if (ct==4) 	
					{
						for (ct2=29-r; ct2>c && (ps->fromrc(r+1,ct2)==-1 || b[ps->fromrc(r+1,ct2)]);ct2-=2);
						if (b[ps->fromrc(r+1,ct2)]==0) c+=2;
					}
					if (ct==5) {c-=2;}
					if (ct==6) {c+=2;}
					if (ct==7) {c--; r--;}
					if (ct==8) {c++; r--;}
				}
				else
				{
					if (ct==2) {c--; r++;}
					if (ct==1) {c++; r++;}
					if (ct==4) 
					{
						for (ct2=r-3;(ct2<c)&&((ps->fromrc(r+1,ct2)==-1)||(b[ps->fromrc(r+1,ct2)]!=0));ct2+=2);
						if (b[ps->fromrc(r+1,ct2)]==0) c-=2;
					}
					if (ct==3)
					{
						for (ct2=29-r;(ct2>c)&&((ps->fromrc(r+1,ct2)==-1)||(b[ps->fromrc(r+1,ct2)]!=0));ct2-=2);
						if (b[ps->fromrc(r+1,ct2)]==0) c+=2;
					}
					if (ct==6) {c-=2;}
					if (ct==5) {c+=2;}
					if (ct==7) {c--; r--;}
					if (ct==8) {c++; r--;}
				}
				cur=ps->fromrc(r,c);
				ok= ( cur!=-1 && !b[cur] );
				if ( ok && ( cur==23 || cur==11 || cur==21 || cur==34 || cur==86 || cur==99 || cur==97 || cur==109 ))
					ok=0;
			}
		}
	x--;
	if (ok)
	{
		bm[0]=p[x];
		bm[1]=ps->fromrc(r,c);
		bm[2]=-1;
		*bw=mmevalmove(bm, b);
	}
	return(0);
}

int move(PlayerState *_ps, int plyr, int status ,int err, int *b, int *m)
{
	int count=0, ct, ct2=0, bm[100], p[10];
	float bw;

	ps=_ps;
	if ((status>6)&&(status==2)&&(status==3)) return(0);
	/*get peice positions*/
	for(ct=0;ct<121;ct++) if (b[ct]==plyr) p[ct2++]=ct;
	/*init bestmove and weight*/
	bw=0;
	bm[0]=-1;

	/*call slider first to find slide move to compare jumps to*/
	mmslider (b, bm, p, &bw);

	/*now find best jump for each piece and get best jump from all of them*/
	for (ct=0;ct<10;ct++)
	{
		m[0]=p[ct];
		m[1]=-1;
		mmfindjump(m,b,1,bm,&bw);
	}

	for(ct=0;bm[ct]>-1;ct++) 
	m[ct]=bm[ct];
	m[ct]=-1;
	return(0);
}
