#include "CC.h"
#include <SDL_image.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>

JASDL_Font *font;
SDL_Surface *ccmarble[6];
SDL_Surface *ccgadget[3];
SDL_Surface *ccboard,*winbuf,*newwinbuf,*oldwinbuf,*selection;
Mix_Music *music[5];
Mix_Chunk *sfx[7];

char *dataFName(char *str)
{
	static char fname[4096];
	struct stat buf;

	sprintf(fname,"./%s",str);
	if(stat(fname, &buf)<0)
		sprintf(fname,SDLCC_PATH"/%s",str);
	return(fname);
}

int startgui()
{
	int w,h,i;
	SDL_Surface *surf,*title;
	char *CCMarble[]={
		"images/CCRedMarble.png",
		"images/CCYellowMarble.png",
		"images/CCGreenMarble.png",
		"images/CCCyanMarble.png",
		"images/CCBlueMarble.png",
		"images/CCPurpleMarble.png"
	};
	char *CCGadget[]={
		"images/CCGadget1.png",
		"images/CCGadget2.png",
		"images/CCGadget3.png"
	};
	char *Wav[]={
		"sounds/hmm.wav",
		"sounds/awman.wav",
		"sounds/click.wav",
		"sounds/clickoff.wav",
		"sounds/woohoo.wav",
		"sounds/marble.wav",
		"sounds/computer.wav"
	};
	char *Music[]={
		"sounds/lemon.mod",
		"sounds/DesertDreamVol.mod",
		"sounds/Kakofonia.mod",
		"sounds/TeadropInAPot.mod",
		"sounds/Chipgene.mod"
	};
	
	JASDL_Init();
	
	title=IMG_Load(dataFName("images/CCTitle.png"));
	if(!title)
		JASDL_Exit("IMG_ReadXPMFromArray: CCtitle.png");

	SDL_WM_SetCaption("ChineseCheckers : by Jon Atkins <jcatki@home.com>","sdlCC");
	
	ccboard=IMG_Load(dataFName("images/CCBoard.png"));
	if(!ccboard)
		JASDL_Exit("IMG_ReadXPMFromArray: CCBoard.png");

	w=ccboard->w;
	h=ccboard->h;

	if(Mix_OpenAudio(44100, MIX_DEFAULT_FORMAT, 1, 1024)<0)
		JASDL_Exit("Mix_OpenAudio");

	channels=Mix_AllocateChannels(9)-1;
	channel=0;

	if(!(s=SDL_SetVideoMode(w,h,0,/*SDL_FULLSCREEN|*/SDL_ANYFORMAT|SDL_DOUBLEBUF|SDL_SWSURFACE)))
		JASDL_Exit("SDL_SetVideoMode");

	title=JASDL_DisplayFormatAlpha(title);
	SDL_BlitSurface(title,NULL,s,NULL);
	UpdateWin(0);

	for(i=0;i<5;i++)
	{
		if(!( music[i]=Mix_LoadMUS(dataFName(Music[i])) ))
			JASDL_Exit("Mix_LoadMUS(\"%s\")",dataFName(Music[i]));
	}

	Mix_PlayMusic(music[0],-1);

	for(i=0;i<7;i++)
	{
		if(!( sfx[i]=Mix_LoadWAV(dataFName(Wav[i])) ))
			JASDL_Exit("Mix_LoadWAV(\"%s\")",dataFName(Wav[i]));
	}
	
	ccboard=JASDL_DisplayFormatAlpha(ccboard);

	surf=IMG_Load(dataFName("images/font.png"));
	font=JASDLFont_Create(surf);
	JASDLFont_DisplayFormatAlpha(font);

	selection=IMG_Load(dataFName("images/CCSelection.png"));
	if(!selection)
		JASDL_Exit("IMG_Load: %s",dataFName("images/CCSelection.png"));
	selection=JASDL_DisplayFormatAlpha(selection);
	
	for (i=0;i<6;i++)
	{
		ccmarble[i]=IMG_Load(dataFName(CCMarble[i]));
		if(!ccmarble[i])
			JASDL_Exit("IMG_Load: CCMarble[%d]=%s",i,dataFName(CCMarble[i]));
		ccmarble[i]=JASDL_DisplayFormatAlpha(ccmarble[i]);
	}

	for (i=0;i<3;i++)
	{
		ccgadget[i]=IMG_Load(dataFName(CCGadget[i]));
		if(!ccgadget[i])
			JASDL_Exit("IMG_Load: CCGadget[%d]=%s",i,dataFName(CCGadget[i]));
		ccgadget[i]=JASDL_DisplayFormatAlpha(ccgadget[i]);
	}

	winbuf=JASDL_CopySurface(s,NULL);
	newwinbuf=JASDL_CopySurface(s,NULL);
	oldwinbuf=JASDL_CopySurface(s,NULL);
	
	handleEvent=handleEvents;

	getclick(0);

	for(i=0;i<100;i++)
	{
		for(w=0;w<10;w++)
		{
			PutMarble(rand()%6,rand()%s->w,rand()%s->h);
		}
		UpdateWin(0);
	}

	return(1);
}
